//programmed using HiTechC
#include <pic.h>
#include <stdio.h>

int TMPH,TMPL,TMBF;
void Initialize_settings(void);

main()
{

Initialize_settings();
//TMR1ON=1;//Start Timer
while(1){

while(TRMT!=1);			
	TXREG=0xAA;
	
#asm
//CLEAR ALL INTERRUPTS
CLRF _INTCON
//rEAD HIGH BYTE
MOVF _TMR1H,W
MOVWF _TMPH
//READ LOW BYTE
MOVF _TMR1L,W
MOVWF _TMPL
//READ HIGH BYTE
MOVF _TMR1H,W
//SUB 1ST READ VALUE WITH THE 2ND READ
SUBWF _TMPH, W
BTFSC _STATUS,2 //IS RESULT =0,checking z bit
GOTO CONTINUE //GOOD 16 BIT READ
//TIMR1L MAY HAVE ROLLED OVER WHEN HIGH BYTE WAS READ
MOVF _TMR1H,W //rEAD HIGH BYTE
MOVWF _TMPH
MOVF _TMR1L,W  //READ LOW BYTE
MOVWF _TMPL

CONTINUE   NOP


#endasm

PEIE=1;
TMR1IE=1;//Timer 1 interrupt enabled
//TRMT=0;
    
while(TRMT!=1);			
TXREG=TMPH;
while(TRMT!=1);			
TXREG=TMPL;

if(TMR1IF==1)
{
	TMBF++;
	TMR1IF=0;
	TMR1H=0x00;
	TMR1L=0x00;
}	
	while(TRMT!=1);			
	TXREG=TMBF;
}
}


void Initialize_settings()
{
	PORTA=0X00;
	PORTB=0X00;
	PORTC=0X00;
	PORTD=0X00;
	PORTE=0X00;
    TRISA=0X00;
    TRISB=0X00;
    TRISC=0X8F;//  port configured as 1000 1111
    TRISD=0XFF;
    TRISE=0X00; 
	PSPMODE=0;
    ADCON1=0x06;  // Porta setting all port a configured as input
    TXSTA=0x84;  //1000 0100 USART in Asynchronous,high speed,transmit disabled mode
    TXEN=1;	//transmit enabled mode
    SPBRG=0x0C;  //Baudrate is 19200 ,FOSC=4MHz  Formulae is   Baudrate = FOSC/16(x+1)    
    RCIE=0;  //Receive interrupt enable bit
    CREN=0;    // continous receive enable bit
    SPEN=1;   // serial port enble bit
    SYNC=0;//Selecting Asynchronous mode
	RBIE=0;//  disable rb port change interrupt, to be used when port b is used as external interrupt
	INTE=0;// disable rb0  change interrupt
    GIE=1;  // Global Interrupt Enable bit high
    //START OF Configuration of different bits of T1CON
    T1CKPS0=0;
	T1CKPS1=0;//prescaler is 1:1
	T1OSCEN=1;//for pin RC1 as external clock input
	T1SYNC=1;// DO NOT SYNCHRONIZE TO EXTERNAL CLOCK INPUT
    TMR1CS=1;//for external clock as rising edge
	TMR1ON=1;//Stop/start Timer
	
	RB1=0; //for rs 485 selection 1 for rs 232 make it 0 
	PEIE=1; // to enable any peripheral interrupt this must be set
	 
	TMR1IF=0;//Timer1 overflow made zero
	TMR1IE=1;//Timer 1 interrupt enabled
	TMR1H=0x00;
	TMR1L=0x00;
	TMBF=0x00;
	GIE=1;
}
